module RuGPost

	META = /--- \n.*\n---\n/m

	DRAFTS =  'drafts'
	PUBLISHED = 'published'
	SOURCE = PUBLISHED/'source'
	OUTPUT = PUBLISHED/'output'

	class Post

		attr_accessor :src_body, :draft, :subject, :html_o, :metaops, :pwd

		def initialize(args,ops)
			ops[:site]=Post.get_site(ops)
			@draftid = args[0]
			@pwd = args[1]
			@draft = Dir.glob(ops[:site]/DRAFTS/@draftid+".*")
			raise "Draft not found! Searched for '#{args[0]}' in '#{ops[:site]}/drafts'" unless @draft
			@draft = @draft[0]
			set_body
			set_html
			set_meta ops
			set_subj
		end

		def set_meta ops
			projectops = YAML.load_file(CONFIG)
			@metaops = YAML.load_file(@draft)
			@metaops.merge! projectops
			@metaops.merge! ops
		end

		def set_subj
			@subject = "#{@metaops[:title]} ((tags:#{@metaops[:tags].join(',')}))"
			@subject += "((delay:#{@metaops[:delay]}))" if @metaops[:delay]
		end

		def set_body
			cnt = ""
			File.open( @draft, 'r' ) { |str| cnt << str.read() }
			@src_body = cnt.sub META, ""
		end

		def set_html
			@html_o = RedCloth.new(@src_body).to_html		
		end

		def move_source
			FileUtils.mv(@draft,@metaops[:site]/SOURCE)
		end

		def move_html
			target = @metaops[:site]/OUTPUT/@draftid+'.html'
			File.open( target, 'w' ) {|f| f.write(@html_o)}
		end

		def remove
			FileUtils.remove_file(@draft)
		end

		def Post.draft(args,ops)
			ops[:site]=Post.get_site(ops)
			raise "Please provide draft name!" if !args[0]
			target_file = ops[:site]/'drafts'/args[0]+'.textile'
			puts "Adding draft '#{args[0]}' to site repo '#{ops[:site]}'..."
			raise "File already exists!\n\t#{target_file}\n\tPlease indicate a different draft name." if File.exists?(target_file)
			FileUtils.copy_file(TEMPLATE, target_file)
		end

		def Post.publish(post)
			account = "#{post.metaops[:gmail]}@gmail.com"
			gmail = Gmail.new(account,post.pwd)
			gmail.deliver do
				to "#{post.metaops[:site]}@posterous.com"
				subject post.subject
				text_part do
					body post.html_o
				end
			end
			gmail.logout
			post.move_source
			post.move_html
		end

		def Post.get_site(ops)
		 if ops[:site]==nil then
				ops[:site]=Dir.glob('*').select {|d| File.directory? d}[0]
				puts "No site name option provided, switching to default...'#{ops[:site]}'"
		 end
		 return ops[:site]
		end

	end

end
